Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

const ExtHotmailGuid = "{3c8e8390-2cf6-11d9-9669-0800200c9a66}";

/******************************  Hotmail ***************************************/
function nsHotmailSMTP()
{
    try
    {
        var scriptLoader =  Components.classes["@mozilla.org/moz/jssubscript-loader;1"];
        scriptLoader = scriptLoader.getService(Components.interfaces.mozIJSSubScriptLoader);
        scriptLoader.loadSubScript("chrome://web-mail/content/common/DebugLog.js");
        scriptLoader.loadSubScript("chrome://web-mail/content/common/CommonPrefs.js");
        scriptLoader.loadSubScript("chrome://hotmail/content/Hotmail-Prefs-Data.js");
        scriptLoader.loadSubScript("chrome://hotmail/content/Hotmail-ScreenRipper-SMTP-BETA.js");

        var date = new Date();
        var  szLogFileName = "Hotmail SMTP Log - " + date.getHours()
                                           + "-" + date.getMinutes()
                                           + "-"+ date.getUTCMilliseconds() +" -";
        this.m_Log = new DebugLog("webmail.logging.comms", ExtHotmailGuid, szLogFileName);
        this.m_Log.Write("nsHotmailSMTP.js - Constructor - START");

        if (typeof kHotmailConstants == "undefined")
        {
            this.m_Log.Write("nsLycos.js - Constructor - loading constants");
            scriptLoader.loadSubScript("chrome://hotmail/content/Hotmail-Constants.js");
        }

        this.m_szUserName = null;
        this.m_szPassWord = null;
        this.m_oResponseStream = null;
        this.m_aszTo = new Array();
        this.m_szFrom = null;
        this.m_CommMethod = null;

        this.m_Log.Write("nsHotmailSMTP.js - Constructor - END");
    }
    catch(err)
    {
        DebugDump("nsHotmailSMTP.js: Constructor : Exception : "
                                      + err.name
                                      + ".\nError message: "
                                      + err.message +"\n" +
                                      err.lineNumber);
    }
}




nsHotmailSMTP.prototype =
{
    classDescription : "Webmail Hotmail mail SMTP",
    classID          : Components.ID("{8b9baa40-1296-11da-8cd6-0800200c9a66}"),
    contractID       : "@mozilla.org/HotmailSMTP;1",

    QueryInterface : XPCOMUtils.generateQI([Components.interfaces.nsISupports,
                                            Components.interfaces.nsISMTPDomainHandler]),


    get userName() {return this.m_szUserName;},
    set userName(userName) {return this.m_szUserName = userName;},

    get passWord() {return this.m_szPassWord;},
    set passWord(passWord) {return this.m_szPassWord = passWord;},

    get ResponseStream() {return this.m_oResponseStream;},
    set ResponseStream(responseStream) {return this.m_oResponseStream = responseStream;},

    get to() {return this.m_aszTo;},
    set to(szAddress) {return this.m_aszTo.push(szAddress);},

    get from() {return this.m_szFrom;},
    set from(szAddress) {return this.m_szFrom = szAddress;},

    get bAuthorised()
    {
        return (this.m_CommMethod)? this.m_CommMethod.m_bAuthorised: false;
    },




    logIn : function()
    {
        try
        {
            this.m_Log.Write("nsHotmailSMTP.js - logIN - START");
            this.m_Log.Write("nsHotmailSMTP.js - logIN - Username: " + this.m_szUserName
                                                   + " Password: " + this.m_szPassWord
                                                   + " stream: " + this.m_oResponseStream);

            if (!this.m_szUserName || !this.m_oResponseStream  || !this.m_szPassWord) return false;

            //load prefs
            var PrefData = this.getPrefs();

            this.m_CommMethod = new HotmailSMTPScreenRipperBETA(this.m_oResponseStream, this.m_Log, PrefData);

            var bResult = this.m_CommMethod.logIn(this.m_szUserName, this.m_szPassWord);

            this.m_Log.Write("nsHotmailSMTP.js - logIN - "+ bResult +"- END");
            return bResult;
        }
        catch(err)
        {
            this.m_Log.DebugDump("nsHotmailSMTP.js: logIN : Exception : "
                                              + err.name +
                                              ".\nError message: "
                                              + err.message+ "\n"
                                              + err.lineNumber);

            this.serverComms("502 negative vibes\r\n");
            return false;
        }
    },



    rawMSG : function (szEmail)
    {
        try
        {
            this.m_Log.Write("nsHotmailSMTP.js - rawMSG - START");
            this.m_Log.Write("nsHotmailSMTP.js - rawMSG from " +this.m_szFrom );
            this.m_Log.Write("nsHotmailSMTP.js - rawMSG to " +this.m_aszTo );
            this.m_Log.Write("nsHotmailSMTP.js - rawMSG " + szEmail);

            var bResult = this.m_CommMethod.rawMSG(this.m_szFrom, this.m_aszTo, szEmail);

            this.m_Log.Write("nsHotmailSMTP.js - rawMSG -" + bResult +" END");
            return bResult;
        }
        catch(err)
        {
            this.m_Log.DebugDump("nsHotmailSMTP.js: rawMSG : Exception : "
                                              + err.name +
                                              ".\nError message: "
                                              + err.message+ "\n"
                                              + err.lineNumber);

            this.serverComms("502 negative vibes\r\n");
            return false;
        }
    },


   serverComms : function (szMsg)
    {
        try
        {
            this.m_Log.Write("nsHotmailSMTP - serverComms - START");
            this.m_Log.Write("nsHotmailSMTP - serverComms msg " + szMsg);
            var iCount = this.m_oResponseStream.write(szMsg,szMsg.length);
            this.m_Log.Write("nsHotmailSMTP - serverComms sent count: " + iCount
                                                        +" msg length: " +szMsg.length);
            this.m_Log.Write("nsHotmailSMTP - serverComms - END");
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsHotmailSMTP: serverComms : Exception : "
                                              + e.name
                                              + ".\nError message: "
                                              + e.message+ "\n"
                                              + e.lineNumber);
        }
    },




    getPrefs : function ()
    {
        try
        {
            this.m_Log.Write("nsHotmailSMTP.js - getPrefs - START");

            var WebMailPrefAccess = new WebMailCommonPrefAccess();
            var oPref = {Value : null};
            var oData = new PrefData();

            var szUserName =  this.m_szUserName;
            szUserName = szUserName.replace(/\./g,"~");
            szUserName = szUserName.toLowerCase();

            //do i reuse the session
            if (WebMailPrefAccess.Get("bool","hotmail.bReUseSession",oPref))
                oData.bReUseSession = oPref.Value;
            this.m_Log.Write("nsHotmailSMTP.js - getPrefs - hotmail.bReUseSession " + oPref.Value);

            //do i save copy
            oPref.Value = null;
            if (WebMailPrefAccess.Get("bool","hotmail.Account."+szUserName+".bSaveCopy",oPref))
                oData.bSaveCopy=oPref.Value;
            this.m_Log.Write("nsHotmailSMTP.js - getPrefs - bSaveCopy " + oPref.Value);

            //what do i do with alternative parts
            oPref.Value = null;
            if (WebMailPrefAccess.Get("bool","hotmail.Account."+szUserName+".bSendHtml",oPref))
                oData.bSendHtml = oPref.Value;
            this.m_Log.Write("nsHotmailSMTP.js - getPrefs - bSendHtml " + oPref.Value);

            this.m_Log.Write("nsHotmailSMTP.js - getPrefs - END");
            return oData;
        }
        catch(e)
        {
            this.m_Log.DebugDump("nsHotmailSMTP.js: getPrefs : Exception : "
                                      + e.name
                                      + ".\nError message: "
                                      + e.message+ "\n"
                                      + e.lineNumber);
            return null;
        }
    }
};


/**
* XPCOMUtils.generateNSGetFactory was introduced in Mozilla 2 (Firefox 4).
* XPCOMUtils.generateNSGetModule is for Mozilla 1.9.2 (Firefox 3.6).
*/
if (XPCOMUtils.generateNSGetFactory)
    var NSGetFactory = XPCOMUtils.generateNSGetFactory([nsHotmailSMTP]);
else
    var NSGetModule = XPCOMUtils.generateNSGetModule([nsHotmailSMTP]);